-- ----------------------------------------------------------------------------
Library IEEE;
Use     IEEE.Std_Logic_1164.All;
Use     IEEE.Std_Logic_Unsigned.All;
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
Entity AppleVideoTiming Is
    Port (
        clk28        : In  Std_Logic;
        AppleII_Reset : In Std_Logic;
        vga_HS       : Out Std_Logic;
        vga_VS       : Out Std_Logic;
        HBL          : Out Std_Logic;
        VBL          : Out Std_Logic;
        LDPS         : Out Std_Logic;
        BusCycle     : out Std_Logic_Vector(4 Downto 0);
        flash_count4 : Out Std_Logic;
        CounterX     : Out Std_Logic_Vector(6 Downto 0);
        CounterY     : Out Std_Logic_Vector(9 Downto 0)
    );
End;
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
Architecture RTL Of AppleVideoTiming Is
-- ----------------------------------------------------------------------------

    Signal BusCycle_sig     : Std_Logic_Vector(4 Downto 0);
--    Signal Line_Sig         : Std_Logic_Vector(7 Downto 0);
    Signal flash_count4_sig : Std_Logic_Vector(4 Downto 0);
    Signal CounterX_Sig     : Std_Logic_Vector(6 Downto 0);
    Signal CounterY_Sig     : Std_Logic_Vector(9 Downto 0);
    Signal LDPS_Sig         : Std_Logic;
    Signal VBL_Sig          : Std_Logic;
-- ----------------------------------------------------------------------------
Begin
-- ----------------------------------------------------------------------------

    BusCycle <= BusCycle_sig;
    -- ------------------------------------------------------------------------
    Process(clk28)
    Begin
        If Rising_Edge(clk28) Then
--            If AppleII_Reset='1' Then
--                BusCycle_sig <= (Others=>'0');
--            Else
                If (BusCycle_sig = "11011") Then --27
                    BusCycle_sig <= (Others=>'0');
                Else
                    BusCycle_sig <= BusCycle_sig + 1;
                End If;
--            End If;
        End If;
    End Process;
    -- ------------------------------------------------------------------------

    CounterX     <= CounterX_Sig;
    CounterY     <= CounterY_Sig;
    LDPS         <= LDPS_Sig;
    LDPS_Sig     <= '1' When ((BusCycle_Sig="00011") Or (BusCycle_Sig="10001")) Else '0';
    flash_count4 <= flash_count4_sig(4);
    -- ------------------------------------------------------------------------
    Process(clk28)
    Begin
        If Rising_Edge(clk28) Then
            If AppleII_Reset='1' Then
                vga_HS           <= '0';
                vga_VS           <= '0';
                CounterX_Sig     <= (Others=>'0');
                CounterY_Sig     <= (Others=>'0');
                flash_count4_sig <= (Others=>'0');
--                Line_Sig         <= (Others=>'0');
            Else

                If (CounterX_Sig(6 Downto 2) = "10010") Then vga_HS <= '1';
                                                        Else vga_HS <= '0';
                End If;
                If (CounterY_Sig = "1111000000")        Then vga_VS <= '1';
                                                        Else vga_VS <= '0';
                End If;


                If (LDPS_Sig='1') Then
                    If (CounterX_Sig(6) = '0') Then
                        CounterX_Sig <= "1000000";
                        If (CounterY_Sig = "1111111111") Then
                            CounterY_Sig <= "0111110100";
                            flash_count4_sig <= flash_count4_sig + 1;
--                            Line_Sig <= (Others=>'0');
                        Else
                            CounterY_Sig <= CounterY_Sig + 1;
--                            If (VBL_Sig='0' And CounterY_Sig(0)='0') Then
--                                Line_Sig <= Line_Sig + 1;
--                            End If;
                        End If;

                    Else
                        CounterX_Sig <= CounterX_Sig + 1;
                    End If;
                End If;
            End If;
        End If;
    End Process;
    -- ------------------------------------------------------------------------
    HBL <= Not CounterX_Sig(5) And (Not CounterX_Sig(4) Or Not CounterX_Sig(3));
    VBL_Sig <= (CounterY_Sig(8) And CounterY_Sig(7));
    VBL <= VBL_Sig;
-- ----------------------------------------------------------------------------
End RTL;
-- ----------------------------------------------------------------------------
