-- ----------------------------------------------------------------------------
Library IEEE;
Use     IEEE.Std_Logic_1164.All;
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
Package AsciiTranslation Is
    -- Define AppleII keyboard scan codes (expanded number of bits to 12)
    Constant cKey_066 : Std_Logic_Vector(11 Downto 0) := X"066";
    Constant cKey_00D : Std_Logic_Vector(11 Downto 0) := X"00D";
    Constant cKey_05A : Std_Logic_Vector(11 Downto 0) := X"05A";
    Constant cKey_076 : Std_Logic_Vector(11 Downto 0) := X"076";
    Constant cKey_029 : Std_Logic_Vector(11 Downto 0) := X"029";
    Constant cKey_166 : Std_Logic_Vector(11 Downto 0) := X"166";
    Constant cKey_10D : Std_Logic_Vector(11 Downto 0) := X"10D";
    Constant cKey_15A : Std_Logic_Vector(11 Downto 0) := X"15A";
    Constant cKey_176 : Std_Logic_Vector(11 Downto 0) := X"176";
    Constant cKey_129 : Std_Logic_Vector(11 Downto 0) := X"129";
    Constant cKey_116 : Std_Logic_Vector(11 Downto 0) := X"116";
    Constant cKey_152 : Std_Logic_Vector(11 Downto 0) := X"152";
    Constant cKey_126 : Std_Logic_Vector(11 Downto 0) := X"126";
    Constant cKey_125 : Std_Logic_Vector(11 Downto 0) := X"125";
    Constant cKey_12E : Std_Logic_Vector(11 Downto 0) := X"12E";
    Constant cKey_13D : Std_Logic_Vector(11 Downto 0) := X"13D";
    Constant cKey_052 : Std_Logic_Vector(11 Downto 0) := X"052";
    Constant cKey_146 : Std_Logic_Vector(11 Downto 0) := X"146";
    Constant cKey_145 : Std_Logic_Vector(11 Downto 0) := X"145";
    Constant cKey_13E : Std_Logic_Vector(11 Downto 0) := X"13E";
    Constant cKey_155 : Std_Logic_Vector(11 Downto 0) := X"155";
    Constant cKey_041 : Std_Logic_Vector(11 Downto 0) := X"041";
    Constant cKey_04E : Std_Logic_Vector(11 Downto 0) := X"04E";
    Constant cKey_049 : Std_Logic_Vector(11 Downto 0) := X"049";
    Constant cKey_04A : Std_Logic_Vector(11 Downto 0) := X"04A";
    Constant cKey_045 : Std_Logic_Vector(11 Downto 0) := X"045";
    Constant cKey_016 : Std_Logic_Vector(11 Downto 0) := X"016";
    Constant cKey_01E : Std_Logic_Vector(11 Downto 0) := X"01E";
    Constant cKey_026 : Std_Logic_Vector(11 Downto 0) := X"026";
    Constant cKey_025 : Std_Logic_Vector(11 Downto 0) := X"025";
    Constant cKey_02E : Std_Logic_Vector(11 Downto 0) := X"02E";
    Constant cKey_036 : Std_Logic_Vector(11 Downto 0) := X"036";
    Constant cKey_03D : Std_Logic_Vector(11 Downto 0) := X"03D";
    Constant cKey_03E : Std_Logic_Vector(11 Downto 0) := X"03E";
    Constant cKey_046 : Std_Logic_Vector(11 Downto 0) := X"046";
    Constant cKey_14C : Std_Logic_Vector(11 Downto 0) := X"14C";
    Constant cKey_04C : Std_Logic_Vector(11 Downto 0) := X"04C";
    Constant cKey_141 : Std_Logic_Vector(11 Downto 0) := X"141";
    Constant cKey_055 : Std_Logic_Vector(11 Downto 0) := X"055";
    Constant cKey_149 : Std_Logic_Vector(11 Downto 0) := X"149";
    Constant cKey_14A : Std_Logic_Vector(11 Downto 0) := X"14A";
    Constant cKey_11E : Std_Logic_Vector(11 Downto 0) := X"11E";
    Constant cKey_11C : Std_Logic_Vector(11 Downto 0) := X"11C";
    Constant cKey_132 : Std_Logic_Vector(11 Downto 0) := X"132";
    Constant cKey_121 : Std_Logic_Vector(11 Downto 0) := X"121";
    Constant cKey_123 : Std_Logic_Vector(11 Downto 0) := X"123";
    Constant cKey_124 : Std_Logic_Vector(11 Downto 0) := X"124";
    Constant cKey_12B : Std_Logic_Vector(11 Downto 0) := X"12B";
    Constant cKey_134 : Std_Logic_Vector(11 Downto 0) := X"134";
    Constant cKey_133 : Std_Logic_Vector(11 Downto 0) := X"133";
    Constant cKey_143 : Std_Logic_Vector(11 Downto 0) := X"143";
    Constant cKey_13B : Std_Logic_Vector(11 Downto 0) := X"13B";
    Constant cKey_142 : Std_Logic_Vector(11 Downto 0) := X"142";
    Constant cKey_14B : Std_Logic_Vector(11 Downto 0) := X"14B";
    Constant cKey_13A : Std_Logic_Vector(11 Downto 0) := X"13A";
    Constant cKey_131 : Std_Logic_Vector(11 Downto 0) := X"131";
    Constant cKey_144 : Std_Logic_Vector(11 Downto 0) := X"144";
    Constant cKey_14D : Std_Logic_Vector(11 Downto 0) := X"14D";
    Constant cKey_115 : Std_Logic_Vector(11 Downto 0) := X"115";
    Constant cKey_12D : Std_Logic_Vector(11 Downto 0) := X"12D";
    Constant cKey_11B : Std_Logic_Vector(11 Downto 0) := X"11B";
    Constant cKey_12C : Std_Logic_Vector(11 Downto 0) := X"12C";
    Constant cKey_13C : Std_Logic_Vector(11 Downto 0) := X"13C";
    Constant cKey_12A : Std_Logic_Vector(11 Downto 0) := X"12A";
    Constant cKey_11D : Std_Logic_Vector(11 Downto 0) := X"11D";
    Constant cKey_122 : Std_Logic_Vector(11 Downto 0) := X"122";
    Constant cKey_135 : Std_Logic_Vector(11 Downto 0) := X"135";
    Constant cKey_11A : Std_Logic_Vector(11 Downto 0) := X"11A";
    Constant cKey_054 : Std_Logic_Vector(11 Downto 0) := X"054";
    Constant cKey_05D : Std_Logic_Vector(11 Downto 0) := X"05D";
    Constant cKey_05B : Std_Logic_Vector(11 Downto 0) := X"05B";
    Constant cKey_136 : Std_Logic_Vector(11 Downto 0) := X"136";
    Constant cKey_14E : Std_Logic_Vector(11 Downto 0) := X"14E";
    Constant cKey_00E : Std_Logic_Vector(11 Downto 0) := X"00E";
    Constant cKey_01C : Std_Logic_Vector(11 Downto 0) := X"01C";
    Constant cKey_032 : Std_Logic_Vector(11 Downto 0) := X"032";
    Constant cKey_021 : Std_Logic_Vector(11 Downto 0) := X"021";
    Constant cKey_023 : Std_Logic_Vector(11 Downto 0) := X"023";
    Constant cKey_024 : Std_Logic_Vector(11 Downto 0) := X"024";
    Constant cKey_02B : Std_Logic_Vector(11 Downto 0) := X"02B";
    Constant cKey_034 : Std_Logic_Vector(11 Downto 0) := X"034";
    Constant cKey_033 : Std_Logic_Vector(11 Downto 0) := X"033";
    Constant cKey_043 : Std_Logic_Vector(11 Downto 0) := X"043";
    Constant cKey_03B : Std_Logic_Vector(11 Downto 0) := X"03B";
    Constant cKey_042 : Std_Logic_Vector(11 Downto 0) := X"042";
    Constant cKey_04B : Std_Logic_Vector(11 Downto 0) := X"04B";
    Constant cKey_03A : Std_Logic_Vector(11 Downto 0) := X"03A";
    Constant cKey_031 : Std_Logic_Vector(11 Downto 0) := X"031";
    Constant cKey_044 : Std_Logic_Vector(11 Downto 0) := X"044";
    Constant cKey_04D : Std_Logic_Vector(11 Downto 0) := X"04D";
    Constant cKey_015 : Std_Logic_Vector(11 Downto 0) := X"015";
    Constant cKey_02D : Std_Logic_Vector(11 Downto 0) := X"02D";
    Constant cKey_01B : Std_Logic_Vector(11 Downto 0) := X"01B";
    Constant cKey_02C : Std_Logic_Vector(11 Downto 0) := X"02C";
    Constant cKey_03C : Std_Logic_Vector(11 Downto 0) := X"03C";
    Constant cKey_02A : Std_Logic_Vector(11 Downto 0) := X"02A";
    Constant cKey_01D : Std_Logic_Vector(11 Downto 0) := X"01D";
    Constant cKey_022 : Std_Logic_Vector(11 Downto 0) := X"022";
    Constant cKey_035 : Std_Logic_Vector(11 Downto 0) := X"035";
    Constant cKey_01A : Std_Logic_Vector(11 Downto 0) := X"01A";
    Constant cKey_154 : Std_Logic_Vector(11 Downto 0) := X"154";
    Constant cKey_15D : Std_Logic_Vector(11 Downto 0) := X"15D";
    Constant cKey_15B : Std_Logic_Vector(11 Downto 0) := X"15B";
    Constant cKey_10E : Std_Logic_Vector(11 Downto 0) := X"10E";
    Constant cKey_071 : Std_Logic_Vector(11 Downto 0) := X"071";
    Constant cKey_074 : Std_Logic_Vector(11 Downto 0) := X"074";
    Constant cKey_06B : Std_Logic_Vector(11 Downto 0) := X"06B";
    Constant cKey_075 : Std_Logic_Vector(11 Downto 0) := X"075";
    Constant cKey_072 : Std_Logic_Vector(11 Downto 0) := X"072";
    Constant cKey_171 : Std_Logic_Vector(11 Downto 0) := X"171";

    -- Define ASCII characters
    Constant cAscii_08 : Std_Logic_Vector(7 Downto 0) := X"08";
    Constant cAscii_09 : Std_Logic_Vector(7 Downto 0) := X"09";
    Constant cAscii_0D : Std_Logic_Vector(7 Downto 0) := X"0D";
    Constant cAscii_1B : Std_Logic_Vector(7 Downto 0) := X"1B";
    Constant cAscii_20 : Std_Logic_Vector(7 Downto 0) := X"20";
    Constant cAscii_21 : Std_Logic_Vector(7 Downto 0) := X"21";
    Constant cAscii_22 : Std_Logic_Vector(7 Downto 0) := X"22";
    Constant cAscii_23 : Std_Logic_Vector(7 Downto 0) := X"23";
    Constant cAscii_24 : Std_Logic_Vector(7 Downto 0) := X"24";
    Constant cAscii_25 : Std_Logic_Vector(7 Downto 0) := X"25";
    Constant cAscii_26 : Std_Logic_Vector(7 Downto 0) := X"26";
    Constant cAscii_27 : Std_Logic_Vector(7 Downto 0) := X"27";
    Constant cAscii_28 : Std_Logic_Vector(7 Downto 0) := X"28";
    Constant cAscii_29 : Std_Logic_Vector(7 Downto 0) := X"29";
    Constant cAscii_2A : Std_Logic_Vector(7 Downto 0) := X"2A";
    Constant cAscii_2B : Std_Logic_Vector(7 Downto 0) := X"2B";
    Constant cAscii_2C : Std_Logic_Vector(7 Downto 0) := X"2C";
    Constant cAscii_2D : Std_Logic_Vector(7 Downto 0) := X"2D";
    Constant cAscii_2E : Std_Logic_Vector(7 Downto 0) := X"2E";
    Constant cAscii_2F : Std_Logic_Vector(7 Downto 0) := X"2F";
    Constant cAscii_30 : Std_Logic_Vector(7 Downto 0) := X"30";
    Constant cAscii_31 : Std_Logic_Vector(7 Downto 0) := X"31";
    Constant cAscii_32 : Std_Logic_Vector(7 Downto 0) := X"32";
    Constant cAscii_33 : Std_Logic_Vector(7 Downto 0) := X"33";
    Constant cAscii_34 : Std_Logic_Vector(7 Downto 0) := X"34";
    Constant cAscii_35 : Std_Logic_Vector(7 Downto 0) := X"35";
    Constant cAscii_36 : Std_Logic_Vector(7 Downto 0) := X"36";
    Constant cAscii_37 : Std_Logic_Vector(7 Downto 0) := X"37";
    Constant cAscii_38 : Std_Logic_Vector(7 Downto 0) := X"38";
    Constant cAscii_39 : Std_Logic_Vector(7 Downto 0) := X"39";
    Constant cAscii_3A : Std_Logic_Vector(7 Downto 0) := X"3A";
    Constant cAscii_3B : Std_Logic_Vector(7 Downto 0) := X"3B";
    Constant cAscii_3C : Std_Logic_Vector(7 Downto 0) := X"3C";
    Constant cAscii_3D : Std_Logic_Vector(7 Downto 0) := X"3D";
    Constant cAscii_3E : Std_Logic_Vector(7 Downto 0) := X"3E";
    Constant cAscii_3F : Std_Logic_Vector(7 Downto 0) := X"3F";
    Constant cAscii_40 : Std_Logic_Vector(7 Downto 0) := X"40";
    Constant cAscii_41 : Std_Logic_Vector(7 Downto 0) := X"41";
    Constant cAscii_42 : Std_Logic_Vector(7 Downto 0) := X"42";
    Constant cAscii_43 : Std_Logic_Vector(7 Downto 0) := X"43";
    Constant cAscii_44 : Std_Logic_Vector(7 Downto 0) := X"44";
    Constant cAscii_45 : Std_Logic_Vector(7 Downto 0) := X"45";
    Constant cAscii_46 : Std_Logic_Vector(7 Downto 0) := X"46";
    Constant cAscii_47 : Std_Logic_Vector(7 Downto 0) := X"47";
    Constant cAscii_48 : Std_Logic_Vector(7 Downto 0) := X"48";
    Constant cAscii_49 : Std_Logic_Vector(7 Downto 0) := X"49";
    Constant cAscii_4A : Std_Logic_Vector(7 Downto 0) := X"4A";
    Constant cAscii_4B : Std_Logic_Vector(7 Downto 0) := X"4B";
    Constant cAscii_4C : Std_Logic_Vector(7 Downto 0) := X"4C";
    Constant cAscii_4D : Std_Logic_Vector(7 Downto 0) := X"4D";
    Constant cAscii_4E : Std_Logic_Vector(7 Downto 0) := X"4E";
    Constant cAscii_4F : Std_Logic_Vector(7 Downto 0) := X"4F";
    Constant cAscii_50 : Std_Logic_Vector(7 Downto 0) := X"50";
    Constant cAscii_51 : Std_Logic_Vector(7 Downto 0) := X"51";
    Constant cAscii_52 : Std_Logic_Vector(7 Downto 0) := X"52";
    Constant cAscii_53 : Std_Logic_Vector(7 Downto 0) := X"53";
    Constant cAscii_54 : Std_Logic_Vector(7 Downto 0) := X"54";
    Constant cAscii_55 : Std_Logic_Vector(7 Downto 0) := X"55";
    Constant cAscii_56 : Std_Logic_Vector(7 Downto 0) := X"56";
    Constant cAscii_57 : Std_Logic_Vector(7 Downto 0) := X"57";
    Constant cAscii_58 : Std_Logic_Vector(7 Downto 0) := X"58";
    Constant cAscii_59 : Std_Logic_Vector(7 Downto 0) := X"59";
    Constant cAscii_5A : Std_Logic_Vector(7 Downto 0) := X"5A";
    Constant cAscii_5B : Std_Logic_Vector(7 Downto 0) := X"5B";
    Constant cAscii_5C : Std_Logic_Vector(7 Downto 0) := X"5C";
    Constant cAscii_5D : Std_Logic_Vector(7 Downto 0) := X"5D";
    Constant cAscii_5E : Std_Logic_Vector(7 Downto 0) := X"5E";
    Constant cAscii_5F : Std_Logic_Vector(7 Downto 0) := X"5F";
    Constant cAscii_60 : Std_Logic_Vector(7 Downto 0) := X"60";
    Constant cAscii_61 : Std_Logic_Vector(7 Downto 0) := X"61";
    Constant cAscii_62 : Std_Logic_Vector(7 Downto 0) := X"62";
    Constant cAscii_63 : Std_Logic_Vector(7 Downto 0) := X"63";
    Constant cAscii_64 : Std_Logic_Vector(7 Downto 0) := X"64";
    Constant cAscii_65 : Std_Logic_Vector(7 Downto 0) := X"65";
    Constant cAscii_66 : Std_Logic_Vector(7 Downto 0) := X"66";
    Constant cAscii_67 : Std_Logic_Vector(7 Downto 0) := X"67";
    Constant cAscii_68 : Std_Logic_Vector(7 Downto 0) := X"68";
    Constant cAscii_69 : Std_Logic_Vector(7 Downto 0) := X"69";
    Constant cAscii_6A : Std_Logic_Vector(7 Downto 0) := X"6A";
    Constant cAscii_6B : Std_Logic_Vector(7 Downto 0) := X"6B";
    Constant cAscii_6C : Std_Logic_Vector(7 Downto 0) := X"6C";
    Constant cAscii_6D : Std_Logic_Vector(7 Downto 0) := X"6D";
    Constant cAscii_6E : Std_Logic_Vector(7 Downto 0) := X"6E";
    Constant cAscii_6F : Std_Logic_Vector(7 Downto 0) := X"6F";
    Constant cAscii_70 : Std_Logic_Vector(7 Downto 0) := X"70";
    Constant cAscii_71 : Std_Logic_Vector(7 Downto 0) := X"71";
    Constant cAscii_72 : Std_Logic_Vector(7 Downto 0) := X"72";
    Constant cAscii_73 : Std_Logic_Vector(7 Downto 0) := X"73";
    Constant cAscii_74 : Std_Logic_Vector(7 Downto 0) := X"74";
    Constant cAscii_75 : Std_Logic_Vector(7 Downto 0) := X"75";
    Constant cAscii_76 : Std_Logic_Vector(7 Downto 0) := X"76";
    Constant cAscii_77 : Std_Logic_Vector(7 Downto 0) := X"77";
    Constant cAscii_78 : Std_Logic_Vector(7 Downto 0) := X"78";
    Constant cAscii_79 : Std_Logic_Vector(7 Downto 0) := X"79";
    Constant cAscii_7A : Std_Logic_Vector(7 Downto 0) := X"7A";
    Constant cAscii_7B : Std_Logic_Vector(7 Downto 0) := X"7B";
    Constant cAscii_7C : Std_Logic_Vector(7 Downto 0) := X"7C";
    Constant cAscii_7D : Std_Logic_Vector(7 Downto 0) := X"7D";
    Constant cAscii_7E : Std_Logic_Vector(7 Downto 0) := X"7E";
    Constant cAscii_7F : Std_Logic_Vector(7 Downto 0) := X"7F";
    Constant cAscii_15 : Std_Logic_Vector(7 Downto 0) := X"15";
--    Constant cAscii_08 : Std_Logic_Vector(7 Downto 0) := X"08";
    Constant cAscii_0B : Std_Logic_Vector(7 Downto 0) := X"0B";
    Constant cAscii_0A : Std_Logic_Vector(7 Downto 0) := X"0A";
--    Constant cAscii_7F : Std_Logic_Vector(7 Downto 0) := X"7F";
    Constant cAscii_00 : Std_Logic_Vector(7 Downto 0) := X"00";
End Package;
-- ----------------------------------------------------------------------------

