-- ----------------------------------------------------------------------------
Library IEEE;
Use     IEEE.Std_Logic_1164.All;
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
Entity DataBuffer Is
    Port (
        CPU_ReadWrite   : In    Std_Logic;
        CPU_DataIn      : In    Std_Logic_Vector(7 Downto 0);
        CPU_DataOut     : Out   Std_Logic_Vector(7 Downto 0);
        CPU_Data0_InOut : InOut Std_Logic;
        CPU_Data1_InOut : InOut Std_Logic;
        CPU_Data2_InOut : InOut Std_Logic;
        CPU_Data3_InOut : InOut Std_Logic;
        CPU_Data4_InOut : InOut Std_Logic;
        CPU_Data5_InOut : InOut Std_Logic;
        CPU_Data6_InOut : InOut Std_Logic;
        CPU_Data7_InOut : InOut Std_Logic
    );
End;
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
Architecture RTL Of DataBuffer Is
-- ----------------------------------------------------------------------------
Begin
-- ----------------------------------------------------------------------------
    CPU_Data0_InOut <= CPU_DataIn(0) When CPU_ReadWrite='1' Else 'Z';
    CPU_Data1_InOut <= CPU_DataIn(1) When CPU_ReadWrite='1' Else 'Z';
    CPU_Data2_InOut <= CPU_DataIn(2) When CPU_ReadWrite='1' Else 'Z';
    CPU_Data3_InOut <= CPU_DataIn(3) When CPU_ReadWrite='1' Else 'Z';
    CPU_Data4_InOut <= CPU_DataIn(4) When CPU_ReadWrite='1' Else 'Z';
    CPU_Data5_InOut <= CPU_DataIn(5) When CPU_ReadWrite='1' Else 'Z';
    CPU_Data6_InOut <= CPU_DataIn(6) When CPU_ReadWrite='1' Else 'Z';
    CPU_Data7_InOut <= CPU_DataIn(7) When CPU_ReadWrite='1' Else 'Z';

    CPU_DataOut <= CPU_Data7_InOut & CPU_Data6_InOut & CPU_Data5_InOut & CPU_Data4_InOut & CPU_Data3_InOut & CPU_Data2_InOut & CPU_Data1_InOut & CPU_Data0_InOut;
-- ----------------------------------------------------------------------------
End RTL;
-- ----------------------------------------------------------------------------

